Require Import mtac.


Program
Definition skolemize {A} {B} {P} : 
  (forall x:A, exists y : B, P x y) -> 
  M (exists f : A -> B, forall x : A, P x (f x))
:=
  fun H=>
  nu x : A,
    let (y, Py) := H x in 
    b <- abs_eq x y;
    let (f, eq) := b in
    let pf' : P x (f x) := _ in
    r <- @abs _ (fun y=>P y (f y)) x pf';
    ret (ex_intro _ f r)
.
Next Obligation.
intros. rewrite eq.
assumption.
Qed.

